/*
 * decext.c - 
 */

/*
 * $Id: decext.c,v 1.5 2005/05/28 14:08:42 komiya Exp $
 *
 *  ------------------------------
 *  DECLARATION of GLOBAL VARIABLE
 *  ------------------------------
 *
 *  File Name : decext.c/h
 *
 */

#include "scheme.h"

#ifndef CTHREAD
#ifdef GCC_SPARC
unsigned int *_active_reg;
unsigned int *_base_reg;
/* register unsigned int    *base_reg asm ("%g3"); */
register unsigned int    *_sp_reg asm ("%g4");
register unsigned int    _reg_reg asm ("%g5");
register unsigned int    _bcpc_reg asm ("%g6");
register unsigned int    *_bcbody_reg asm ("%g7");
#elif defined(GCC_LUNA88K)
register unsigned int    *_active_reg asm ("r23");
register unsigned int    *_base_reg asm ("r24");
register unsigned int    *_sp_reg asm ("r25");
register unsigned int    _reg_reg asm ("r26");
register unsigned int    _bcpc_reg asm ("r27");
register unsigned int    *_bcbody_reg asm ("r28");
#else
unsigned int *_active_reg;
unsigned int *_base_reg;
unsigned int *_sp_reg;
unsigned int _reg_reg;
unsigned int _bcpc_reg;
unsigned int *_bcbody_reg;
#endif
#else /* CTHREAD */
#ifdef USE_REG
# if defined(LUNA)
register REGS *main_thread_regs asm ("r23");
# elif defined(sparc) /* %g5, %g6 */
register REGS *main_thread_regs asm ("%g5");
# endif
#endif
#endif /* CTHREAD */

unsigned int *entity_base;
unsigned int *entity_fin;
int entity_area_size;
int max_entity_area_size;
unsigned int *entity_top;
unsigned int *entity_middle;
unsigned int *entity_bottom;
unsigned int *entity_start;
unsigned int *entity_end;
unsigned int *last_entity;
int entity_position;
float   extent_rate;
HEADER *sheap_start;
HEADER *sheap_end;

int gctype;
int interrupt_enable;
int    no_cons;
int    no_block1;
int    no_block2;
int    ac_cons;
int    ac_block1;
int    ac_block2;

#ifndef CTHREAD

char    *_stack_top;
char    *_stack_bottom;
char    *_stack_area_bottom;

#endif

unsigned int *hash_table;
int hash_table_size;
int hash_bit_mask;

char    *strbuf;
char    *c_strbuf;

SOBJ stdin_port;
SOBJ stdout_port;
SOBJ c_in_port;
SOBJ c_out_port;

SOBJ portlist;
SOBJ ncclist;              /* T.Komiya */
SOBJ wplist;               /* for weak-pair  by T.Komiya */

#ifdef TCPIP
SOBJ conn_timeout;
SOBJ tcp_timeout;
SOBJ udp_timeout;
SOBJ accept_timeout;
SOBJ localhostname;
#endif

SOBJ unbound_obj;
SOBJ eof_obj;
SOBJ sysfun_tracer_body;

unsigned int sctopsym;
unsigned int errsym;            /* By N.Watanabe 92/11/19 */
unsigned int recomsym;          /* By A243 */
unsigned int recomlevel;                /* By A243 */
#ifdef PVM3
unsigned int bctran_exec_form_sym;  /* By A243 */
unsigned int sharp_closure_pvm;     /* By A243 */
unsigned int pvm_recv_function;     /* By A243 */
unsigned int pvm_reduce_function;     /* By A243 */
unsigned int pvm_get_unbound_obj;     /* By A243 */
unsigned int pvm_put_unbound_obj;     /* By A243 */
#endif

SOBJ quotesym;
SOBJ qquotesym;
SOBJ atsym;
SOBJ commasym;
SOBJ c_f_sym;
SOBJ definesym;
SOBJ macrosym;
SOBJ xreturnsym;
SOBJ lreturnsym;
SOBJ xcallsym;
SOBJ mkncsym;
SOBJ struct_sym;
unsigned int debugsym;
unsigned int user_exec_sym;
unsigned int sys_debug_sym;
unsigned int bcloadsym;
SOBJ bc_trace_proc_sym;
SOBJ max_back_trace_depth_sym;
SOBJ gc_message_level_sym;
SOBJ msgc_to_copygc_sym;
SOBJ malloc_list;
SOBJ l_t_e_sym;
#ifdef PVM3
SOBJ pvm_l_t_e_sym;    /* By A243 */
#endif
SOBJ local_fun_sym;
SOBJ beginsym;
SOBJ bcload_with_cip_sym;

#ifdef NIHONGO
SOBJ default_kanji_input_code_sym;
SOBJ default_kanji_output_code_sym;
#ifdef TCPIP
SOBJ default_network_kanji_input_code_sym;
SOBJ default_network_kanji_output_code_sym;
#endif
SOBJ euc_sym;
SOBJ jis_sym;
SOBJ sjis_sym;
SOBJ noc_sym;
#endif

SOBJ print_circle_sym;          /* By ushijima */

#ifndef CTHREAD

unsigned int *_old_top;
unsigned int *_old_top1;

#endif

int transcript_flag;
FILE *transcript_fp;

int system_function_loading_flag;
unsigned int protect_symbol_listsym;
int fas_lib_loading_mess_flag;

unsigned int *bchash;
int bchashsize;
SOBJ bcraw;
SOBJ bcraw2;
SOBJ bcbody;
SOBJ tempp;
SOBJ cdrbody;
SOBJ acode;
SOBJ bcf;
SOBJ bcconst;
SOBJ xfunconst;
SOBJ bcfhead;
BCTABLE bctable[200];
unsigned int *bcdata_hash_table;

int debug1;
int traceflag;

int top_a7;
int top_a6;

#ifndef CTHREAD

unsigned int _reg1;
unsigned int _reg2;
unsigned int _reg3;

/* for continuation */
SOBJ _call_cc_arg;  /*  Yass. Jul. 24 '90  */
SOBJ _top_of_aflk;  /*  Yass. Jul. 24 '90  */
SOBJ _end_of_aflk;  /*  Yass. Jul. 24 '90  */
SOBJ _af_tmp;       /*  Yass. Jul. 24 '90  */
SOBJ _more;         /*  Yass. Jul. 24 '90  */
SOBJ _optcnt;       /*  T.Komiya */

#endif

#ifdef CTHREAD

int current_thread_no;

#endif

#ifdef CALLIOC
unsigned *active_stacks;
unsigned *free_stacks;
#endif
