/*
 * macsave.c - 
 */

/*
 * $Id: macsave.c,v 1.2 1998/10/29 05:11:56 shige Exp $
 */

static char *RCSid="$Id: macsave.c,v 1.2 1998/10/29 05:11:56 shige Exp $";

#include "scheme.h"

#ifndef SAVE_MEM
/*
 *	macsave.c	By T.Komiya  Jan. 3, 1992
 */
 
extern int memget_mode;

Ssave_image()
{
    FILE *fp;
    int *p;
    
    if ((fp = fopen("saved_image", "wb")) == NULL) {
	print_con("\nCan not open freeze file(TUS.img).\n");
	set_reg(LTAG_FALSE);
    } else {
	fwrite(&entity_start, sizeof(int *), 1, fp);
	fwrite(&entity_end, sizeof(int *), 1, fp);
	fwrite(&last_entity, sizeof(int *), 1, fp);
	fwrite(&entity_base, sizeof(int *), 1, fp);
	fputc(gctype, fp);
	fputc(memget_mode, fp);
	fputc(entity_position, fp);
	fwrite(&quotesym.obj, sizeof(int *), 1, fp);
    	fwrite(&qquotesym.obj, sizeof(int *), 1, fp);
	fwrite(&atsym.obj, sizeof(int *), 1, fp);
	fwrite(&commasym.obj, sizeof(int *), 1, fp);
	
	fwrite(&definesym.obj, sizeof(int *), 1, fp);
	fwrite(&macrosym.obj, sizeof(int *), 1, fp);
	fwrite(&xreturnsym.obj, sizeof(int *), 1, fp);
	fwrite(&lreturnsym.obj, sizeof(int *), 1, fp);
	fwrite(&xcallsym.obj, sizeof(int *), 1, fp);
	fwrite(&c_f_sym.obj, sizeof(int *), 1, fp);
	fwrite(&mkncsym.obj, sizeof(int *), 1, fp);
    	fwrite(&sctopsym, sizeof(int *), 1, fp);
	fwrite(&errsym, sizeof(int *), 1, fp);     /* By N.Watanabe 92/11/19 */
	fwrite(&recomsym, sizeof(int *), 1, fp);   /* By A243 */
	fwrite(&recomlevel, sizeof(int *), 1, fp); /* By A243 */
#ifdef PVM3
	fwrite(&bctran_exec_form_sym, sizeof(int *), 1, fp); /* By A243 */
	fwrite(&sharp_closure_pvm, sizeof(int *), 1, fp); /* By A243 */
	fwrite(&pvm_recv_function, sizeof(int *), 1, fp); /* By A243 */
	fwrite(&pvm_reduce_function, sizeof(int *), 1, fp); /* By A243 */
	fwrite(&pvm_get_unbound_obj, sizeof(int *), 1, fp); /* By A243 */
	fwrite(&pvm_put_unbound_obj, sizeof(int *), 1, fp); /* By A243 */
#endif
	fwrite(&debugsym, sizeof(int *), 1, fp);
	fwrite(&user_exec_sym, sizeof(int *), 1, fp);
	fwrite(&sys_debug_sym, sizeof(int *), 1, fp);
	fwrite(&bcloadsym, sizeof(int *), 1, fp);
	fwrite(&bc_trace_proc_sym.obj, sizeof(int *), 1, fp);
	fwrite(&sysfun_tracer_body.obj, sizeof(int *), 1, fp);
	fwrite(&max_back_trace_depth_sym.obj, sizeof(int *), 1, fp);
	fwrite(&gc_message_level_sym.obj, sizeof(int *), 1, fp);
	fwrite(&msgc_to_copygc_sym.obj, sizeof(int *), 1, fp);
	fwrite(&struct_sym.obj, sizeof(int *), 1, fp);
	fwrite(&l_t_e_sym.obj, sizeof(int *), 1, fp);
#ifdef PVM3
	fwrite(&pvm_l_t_e_sym.obj, sizeof(int *), 1, fp); /* By A243 */
#endif
	fwrite(&local_fun_sym.obj, sizeof(int *), 1, fp);
	fwrite(&beginsym.obj, sizeof(int *), 1, fp);
	fwrite(&bcload_with_cip_sym.obj, sizeof(int *), 1, fp);
	
	/* 2nd: the other object which the scheme system hold */
	fwrite(&unbound_obj.obj, sizeof(int *), 1, fp);
	fwrite(&eof_obj.obj, sizeof(int *), 1, fp);
	fwrite(&reg1, sizeof(int *), 1, fp);
	fwrite(&reg2, sizeof(int *), 1, fp);
	fwrite(&reg3, sizeof(int *), 1, fp);
	fwrite(&stdin_port.obj, sizeof(int *), 1, fp);
	fwrite(&stdout_port.obj, sizeof(int *), 1, fp);
	fwrite(&c_in_port.obj, sizeof(int *), 1, fp);
	fwrite(&c_out_port.obj, sizeof(int *), 1, fp);
	fwrite(&bcconst.obj, sizeof(int *), 1, fp);
	fwrite(&xfunconst.obj, sizeof(int *), 1, fp);
	fwrite(&bcraw.obj, sizeof(int *), 1, fp);
	fwrite(&bcraw2.obj, sizeof(int *), 1, fp);
	fwrite(&bcbody.obj, sizeof(int *), 1, fp);
	fwrite(&acode.obj, sizeof(int *), 1, fp);
	fwrite(&tempp.obj, sizeof(int *), 1, fp);
	fwrite(&cdrbody.obj, sizeof(int *), 1, fp);
	fwrite(&bcf.obj, sizeof(int *), 1, fp);
	fwrite(&bcfhead.obj, sizeof(int *), 1, fp);
	fwrite(&call_cc_arg.obj, sizeof(int *), 1, fp);
	fwrite(&top_of_aflk.obj, sizeof(int *), 1, fp);
	fwrite(&end_of_aflk.obj, sizeof(int *), 1, fp);
	fwrite(&af_tmp.obj, sizeof(int *), 1, fp);
	fwrite(&more.obj, sizeof(int *), 1, fp);
#ifdef CTHREAD
    	fwrite(&optcnt.obj, sizeof(int *), 1, fp);
#endif
    	fwrite(&portlist.obj, sizeof(int *), 1, fp);
    	fwrite(&ncclist.obj, sizeof(int *), 1, fp);
    	fwrite(&wplist.obj, sizeof(int *), 1, fp);
	
#ifdef TCPIP
    	fwrite(&conn_timeout.obj, sizeof(int *), 1, fp);
    	fwrite(&tcp_timeout.obj, sizeof(int *), 1, fp);
    	fwrite(&udp_timeout.obj, sizeof(int *), 1, fp);
    	fwrite(&accept_timeout.obj, sizeof(int *), 1, fp);
    	fwrite(&localhostname.obj, sizeof(int *), 1, fp);
#endif
	
#ifdef NIHONGO
    	fwrite(&default_kanji_input_code_sym.obj, sizeof(int *), 1, fp);
    	fwrite(&default_kanji_output_code_sym.obj, sizeof(int *), 1, fp);
#ifdef TCPIP
    	fwrite(&default_network_kanji_input_code_sym.obj, sizeof(int *), 1, fp);
    	fwrite(&default_network_kanji_output_code_sym.obj, sizeof(int *), 1, fp);
#endif
    	fwrite(&euc_sym.obj, sizeof(int *), 1, fp);
    	fwrite(&jis_sym.obj, sizeof(int *), 1, fp);
    	fwrite(&sjis_sym.obj, sizeof(int *), 1, fp);
    	fwrite(&noc_sym.obj, sizeof(int *), 1, fp);
#endif
    	fwrite(&print_circle_sym.obj, sizeof(int *), 1, fp);
	fwrite(hash_table, hash_table_size, 4, fp);
	fwrite(entity_start, last_entity - entity_start, 4, fp);
	fclose(fp);
	set_reg(LTAG_T);
    }
}

#endif
