/*
 * makeobj.c - 
 */

/*
 * $Id: makeobj.c,v 1.2 1998/10/29 05:11:57 shige Exp $
 */

/************************************/
/*                                  */
/*  File Name : makeobj.c           */
/*  Update    : Yass.  Sep. 13 '90  */
/*              Myama. ?            */
/*              Komiya Oct. 26 '90  */
/*                                  */
/*                                  */
/*                                  */
/************************************/

static char *RCSid="$Id: makeobj.c,v 1.2 1998/10/29 05:11:57 shige Exp $";

#include "scheme.h"


mkcons(carobj, cdrobj)
int carobj, cdrobj;
{
    int *entity;
    s_push(cdrobj);
    s_push(carobj);
    entity = (int *)memget(8);
    *entity = s_pop();
    *(entity + 1) = s_pop();
    return(SSERDDA(entity));
}


Pmkvec_nf(size)
int size;
{
    int *entity;
    if (size == 0)
        bokkan("length must be more than zero. (Pmkvec_nf())");
    entity = (int *)memget((size * 4) + 4);
    *entity = LTAG_BLOCK1 | ((size << 2) & 0xfffffffc);
    return((int)entity);
}


mkvec(size)
int size;
{
    int *entity;
    int i;

    if (size == 0)
        return(LTAG_NILVECTOR);
    entity = (int *)memget((size * 4) + 4);
    *entity = LTAG_BLOCK1 | ((size << 2) & 0xfffffffc);
    for (i = 1; i <= size; ++i) 
        *(entity + i) = LTAG_NIL;
    return(LTAG_VECTOR | SSERDDA(entity));
}


Pgetblock2(byte_size)
int byte_size;
{
    int *entity;
    byte_size = ((byte_size + 3) & 0xfffffffc) + 4;
    entity = (int *)memget(byte_size);
    /* *entity = LTAG_BLOCK2 | (((byte_size - 4) << 2) & 0xfffffffc); */
    /*  ^-- koredemo hotondo ugoite ita!!!!!!! kiseki da !!!!! */
    *entity = LTAG_BLOCK2 | (byte_size - 4) ;
    return((int)entity);
}


mkport(filename, direction)  /*  Yass. Sep. 13 '90  */
int filename, direction;
{
    ENTITYP entity;
    FILE * stream;
    unsigned *weakpair;

    char    *strobj_to_str();

#ifdef NIHONGO
    int kincode = fix_to_int(get_sval(get_sval(default_kanji_input_code_sym.obj)));
    int koutcode = fix_to_int(get_sval(get_sval(default_kanji_output_code_sym.obj)));
#endif

    if ((stream = fopen(strobj_to_str(filename),
                        ((direction == INPUT) ? "r" : "w"))) == NULL){
	err_file_error("File open error." , filename); /* By N.Watanabe */
	return NULL;
    }
    s_push(filename);
    entity = (ENTITYP)memget(sizeof(PORT));
    entity->port.head = LTAG_BLOCK1 | 24;
    entity->port.slot.obj = s_pop();
    entity->port.block.com = LTAG_BLOCK2 | 16;
    entity->port.fp = stream;
    if (direction == INPUT) 
        entity->port.kind = INPUT;
    else 
        entity->port.kind = OUTPUT;
#ifdef NIHONGO
/*    *((unsigned *)entity + 5) = ((kincode << 4) | koutcode) & 0x000000ff; */
    *((unsigned *)entity + 5) = 0;
    entity->port.kanji_input_code = kincode;
    entity->port.kanji_output_code = koutcode;
#else
    *((unsigned *)entity + 5) = 0;
#endif

    /* link to port-weak-list */
    reg1 = (LTAG_PORT | SSERDDA(entity));
    weakpair = (unsigned *)memget(20);
    entity = (ENTITYP)ADDRESS(reg1);
    *weakpair = LTAG_BLOCK1 | 16;
    /*  *(weakpair + 1) = portlist.obj; */
    *(weakpair + 1) = get_sval(portlist.obj);
    *(weakpair + 2) = LTAG_BLOCK2 | 8;
    *(weakpair + 3) = reg1;
    *(weakpair + 4) = (int)get_sval(wplist.obj);
    set_sval(wplist.obj, LTAG_WEAKPAIR | SSERDDA(weakpair));

    /*  portlist.obj = LTAG_WEAKPAIR | (unsigned)weakpair; */
    set_sval(portlist.obj, LTAG_WEAKPAIR | SSERDDA(weakpair));
    reg1 = LTAG_NIL;

    return(LTAG_PORT | SSERDDA(entity));
}

mkpipe(stream, direction)
FILE *stream;
int direction;
{
    ENTITYP entity;
    unsigned *weakpair;

    char    *strobj_to_str();

#ifdef NIHONGO
    int kincode = fix_to_int(get_sval(get_sval(default_kanji_input_code_sym.obj)));
    int koutcode = fix_to_int(get_sval(get_sval(default_kanji_output_code_sym.obj)));
#endif

    s_push(mk_str(ORDINARY_STRING, A_STRING, 4, "pipe"));
    entity = (ENTITYP)memget(sizeof(PORT));
    entity->port.head = LTAG_BLOCK1 | 24;
    entity->port.slot.obj = s_pop();
    entity->port.block.com = LTAG_BLOCK2 | 16;
    entity->port.fp = stream;
    if (direction == INPUT) 
        entity->port.kind = INPUT;
    else 
        entity->port.kind = OUTPUT;
#ifdef NIHONGO
/*    *((unsigned *)entity + 5) = ((kincode << 4) | koutcode) & 0x000000ff; */
    *((unsigned *)entity + 5) = 0;
    entity->port.kanji_input_code = kincode;
    entity->port.kanji_output_code = koutcode;
#else
    *((unsigned *)entity + 5) = 0;
#endif

    /* link to port-weak-list */
    reg1 = (LTAG_PORT | SSERDDA(entity));
    weakpair = (unsigned *)memget(20);
    entity = (ENTITYP)ADDRESS(reg1);
    *weakpair = LTAG_BLOCK1 | 16;
    /*  *(weakpair + 1) = portlist.obj; */
    *(weakpair + 1) = get_sval(portlist.obj);
    *(weakpair + 2) = LTAG_BLOCK2 | 8;
    *(weakpair + 3) = reg1;
    *(weakpair + 4) = (int)get_sval(wplist.obj);
    set_sval(wplist.obj, LTAG_WEAKPAIR | SSERDDA(weakpair));

    /*  portlist.obj = LTAG_WEAKPAIR | (unsigned)weakpair; */
    set_sval(portlist.obj, LTAG_WEAKPAIR | SSERDDA(weakpair));
    reg1 = LTAG_NIL;

    return(LTAG_PORT | SSERDDA(entity));
}

mkstdinport()
{
    ENTITYP entity;

    entity = (ENTITYP)memget(sizeof(PORT));
    entity->port.head = LTAG_BLOCK1 | 24;
    entity->port.slot.obj = LTAG_NIL;
    entity->port.block.com = LTAG_BLOCK2 | 16;
    entity->port.fp = stdin;
    entity->port.kind = INPUT;
    *((unsigned *)entity + 5) = 0;
    return(LTAG_PORT | SSERDDA(entity));
}


mkstdoutport()
{
    ENTITYP entity;

    entity = (ENTITYP)memget(sizeof(PORT));
    entity->port.head = LTAG_BLOCK1 | 24;
    entity->port.slot.obj = LTAG_NIL;
    entity->port.block.com = LTAG_BLOCK2 | 16;
    entity->port.fp = stdout;
    entity->port.kind = OUTPUT;
    *((unsigned *)entity + 5) = 0;
    return(LTAG_PORT | SSERDDA(entity));
}


