/*
 * kana.c - 
 */

/*
 * $Id: kana.c,v 1.2 1998/10/29 05:11:55 shige Exp $
 */

#define CtrlSP 0

struct kt_entry {
	char in;
	char out[5];
	int child;
};

#include "kana.out"

character tyi() {
	if (tyiptr > 0) return(tyibuf[--tyiptr]);
	else {
		switch (tyimode) {
		case EUC: return(tyi_kana());
		case SJIS: return(SJISgetc(NULL, tyibuf, &tyiptr));
		default: return(JISgetc(NULL, &tyimode, tyibuf, &tyiptr));
		}
	}
}

int kana_mode = FALSE;
char kana_buf[10];

character tyi_kana() {
	int bp = 0;
	character pc, c = 0;
	while(bp == 0) {
		pc = c;
		c = raw_getchar();
		if (kana_mode) {
			int start = KTSTART;
			for(;; pc = c, c = raw_getchar()) {
				struct kt_entry *next = kana_table+start;
				if (c == CtrlSP) {
					change_kana_mode(FALSE);
					break;
				}
				for(; next->in != 0 && next->in != c; next++);
				if (next->in == c) {
					int i;
					for(i=0; next->out[i] != 0; i++)
						kana_buf[bp++] = next->out[i];
					if ((start = next->child) == 0) 
						break;
				} else if (start == KTSTART)
					return(c);
				else if (pc == 'n') {
					kana_buf[bp++] = '\244';
					kana_buf[bp++] = '\363';
					ungetc(c, stdin);
					break;
				} else
					ring_bell();
			}
		} else if (c == CtrlSP)
			change_kana_mode(TRUE);
		else
			return(c);
	}
	while((--bp) > 0)
		tyibuf[tyiptr++] = kana_buf[bp];
	return(kana_buf[0]);
}
change_kana_mode(flag) {
	int col, row = prow;
	if (row == MSGROW) col = msgcol;
	else col = ccol;
	kana_mode = flag;
	throw_BANNERcursor(3);
	if (nonnil(CSbegin_reverse_video))
		format0(CSbegin_reverse_video);
    if (kana_mode) {tyo('\244'); tyo('\242');}
    else {tyo(' '); tyo('A');}
    if (nonnil(CSend_reverse_video))
		format0(CSend_reverse_video);
	throw_cursor(col, row);
}
