/*
 * misc.c - 
 */

/*
 * $Id: misc.c,v 1.2 1998/10/29 05:11:58 shige Exp $
 *
 *   misc
 *   by M.Yamamoto. 1990
 *
 */

static char *RCSid="$Id: misc.c,v 1.2 1998/10/29 05:11:58 shige Exp $";

#include "scheme.h"

getargnum()
{
    return( ((int)((unsigned *)base_val() - (unsigned *)top_val())) - 1);
}


getargnum2()
{
    unsigned *fun;
    int arginfo;
    fun = (unsigned *)active_val() - 1;
    switch (GETtag(*fun)) {
    case LTAG_BCLOSURE :
        arginfo = *(((int *)ADDRESS(*fun)) + 7);
        if (WITH_REST_MASK & arginfo)
            return(0x3fffffff & (arginfo >> 2));
        else
            return((0x3fffffff & (arginfo >> 2)) - 1);
        break;
    case LTAG_NCLOSURE :
        printf("error at getargnum2: native code closure\n");
        break;
    case LTAG_SFUNCTION :
        arginfo = *(((int *)ADDRESS(*fun)) + 7);
        if (WITH_REST_MASK & arginfo)
            return(getargnum_sysfun_with_rest(base_val(), fun + 1));
        else
            return((0x3fffffff & (arginfo >> 2)) - 1);
        break;
    case LTAG_CONTINUATION :  /* not used ?? */
        printf("error at getargnum2: continuation\n");
        break;
    }
}


getargnum_sysfun_with_rest(base_p, active_p)
unsigned *base_p;
unsigned *active_p;
{
    unsigned *base_p2;
    unsigned *top_obj_p;
    int argnum;
    if (base_p == active_p)
        top_obj_p = (unsigned *)top_val();
    else {
        while (base_p != active_p) {
            base_p2 = base_p;
            base_p = (unsigned *)(*base_p);
        }
        top_obj_p = base_p2 + 4;
    }
    argnum = 0;
    for (base_p2 = active_p - 2; base_p2 >= top_obj_p; base_p2--) {
        if (GETtag(*base_p2) == LTAG_ARG_MARK)
            return(argnum);
        else 
            argnum++;
    }
    return(argnum);
}


